unit Skeleton;

interface
 dfh'fdgh'fdgh';
implementation

uses SysUtils, MNode, HundA, SymT, Mixture, Overlay,
     ExpBitmap, ExpPlot, OAsymT;

var
  IndFile: Text;

procedure WriteSkeleton(MNodeClass: TMNodeClass);
var
  Name: string;
  MNode: TMNode;
  i: Integer;
begin
  MNode := MNodeClass.Create(nil);
  Name := Copy(MNode.ClassType.ClassName,2,255);
  AssignFile(Output,'skel/' + LowerCase(Name) + '.htm');
  Rewrite(Output);
  Writeln('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
  Writeln('<html>');
  Writeln('<head>');
  Writeln('<title>', Name, '</title>');
  Writeln('<body>');
  Writeln('<h1>', Name, '</h1>');
  if MNode.nSettings > 0 then begin
    Writeln('<h2>Settings</h2>');
    Writeln('<table border="1" cellpadding="2" cellspacing="2"><tbody>');
    for i := 1 to MNode.nSettings do begin
      Writeln('<tr><td><a name="', MNode.SettingNames[i], '"></a>', MNode.SettingNames[i], '</td><td>', MNode.HelpOnSetting(i),'</td>');
    end;
    Writeln('</tbody></table>');
  end;
  if MNode.nParameters > 0 then begin
    Writeln('<h2>Parameters</h2>');
    Writeln('<table border="1" cellpadding="2" cellspacing="2"><tbody>');
    for i := 1 to MNode.nParameters do begin
      Writeln('<tr><td><a name="', MNode.ParameterNames[i], '"></a>', MNode.ParameterNames[i], '</td><td>', MNode.HelpOnParameter(i),'</td>');
    end;
    Writeln('</tbody></table>');
  end;
  Writeln('</body>');
  Writeln('</html>');
  CloseFile(Output);
  WriteLn(IndFile, #9'<LI> <OBJECT type="text/sitemap">');
  WriteLn(IndFile, #9#9'<param name="Name" value="', Name, '">');
  WriteLn(IndFile, #9#9'<param name="Local" value="', LowerCase(Name), '">');
  WriteLn(IndFile, #9'</OBJECT>');
  
  for i := 1 to MNode.nSettings do begin
    WriteLn(IndFile, #9'<LI> <OBJECT type="text/sitemap">');
    WriteLn(IndFile, #9#9'<param name="Name" value="', MNode.SettingNames[i], '">');
    WriteLn(IndFile, #9#9'<param name="Local" value="', LowerCase(Name), '.htm#', MNode.SettingNames[i], '">');
    WriteLn(IndFile, #9'</OBJECT>');
  end;
  for i := 1 to MNode.nParameters do begin
    WriteLn(IndFile, #9'<LI> <OBJECT type="text/sitemap">');
    WriteLn(IndFile, #9#9'<param name="Name" value="', MNode.ParameterNames[i], '">');
    WriteLn(IndFile, #9#9'<param name="Local" value="', LowerCase(Name), '.htm#', MNode.ParameterNames[i], '">');
    WriteLn(IndFile, #9'</OBJECT>');
  end;
end;

initialization
  AssignFile(IndFile,'skel/Index.hhk');
  Rewrite(IndFile);

//  WriteSkeleton(TMixture);
//  WriteSkeleton(TSpecies);
//  WriteSkeleton(TCartesianTransitionMoment);
//  WriteSkeleton(TManifold);
//  WriteSkeleton(TMolecule);
//  WriteSkeleton(TPerturbation);
//  WriteSkeleton(TSpecies);
//  WriteSkeleton(TSphericalTransitionMoment);
//  WriteSkeleton(TState);
//  WriteSkeleton(TTransitionMoment);
//  WriteSkeleton(TTransitionMoments);
//  WriteSkeleton(TNucleus);
//  WriteSkeleton(TOverlays);
//  WriteSkeleton(TPlot);
//  WriteSkeleton(TBitmapPlot);
//  WriteSkeleton(TExperimentalPlot);

//  WriteSkeleton(TAsymmetricTop);
//  WriteSkeleton(TAsymmetricTopPerturbation);
//  WriteSkeleton(TAsymmetricManifold);
//  WriteSkeleton(TAsymmetricMolecule);

//  WriteSkeleton(TSymmetricTop);
////  WriteSkeleton(TSymmetricTopPerturbation);
//  WriteSkeleton(TSymmetricManifold);
//  WriteSkeleton(TSymmetricMolecule);

//
//  WriteSkeleton(TLinear);
//  WriteSkeleton(TLinearPerturbation);
//  WriteSkeleton(TLinearManifold);
//  WriteSkeleton(TLinearMolecule);

//  WriteSkeleton(TLinearNucleus);

//  WriteSkeleton(TOrbitalTransitionMoment);
//  WriteSkeleton(TSpinTransitionMoment);

//  WriteSkeleton(TRotationalTransitionMoment);

//  WriteSkeleton(TAsymmetricTopNucleus);
  CloseFile(IndFile);

end.
