unit AlignHelp;
{$I DFS.inc}
{ Alignment Helper Routines }
interface

uses
  Forms, Controls;

procedure AlControl(Control: TControl; Margin: Integer = 0; Side: TAnchorKind = akLeft);
procedure AlForm; { Ensure Form is wide enough to show last control }

implementation

threadvar
  LControl: TControl;

{ Align a sequence of controls }
procedure AlControl(Control: TControl; Margin: Integer = 0; Side: TAnchorKind = akLeft);
begin
  if Assigned(LControl) and Assigned(Control) then
    Control.AnchorToNeighbour(Side,Margin,LControl);
  LControl := Control;
  if Assigned(LControl) then begin
    LControl.AdjustSize;
    LControl.Top := (LControl.Parent.Height - LControl.Height) div 2;
  end;
end;

procedure AlForm; { Ensure Form is wide enough to show last control }
var
  Change: Integer;
  ParentForm: TCustomForm;
begin
  if not Assigned(LControl) then Exit;
  Change := LControl.Left + LControl.Width - LControl.Parent.Width + 4;
  if Change < 2 then
    Exit;
  ParentForm := GetParentForm(LControl);
  if Assigned(ParentForm) then
    ParentForm.Width := ParentForm.Width + Change;
end;

end.

