unit ConstFrm;
{$I DFS.inc}{Copyright (C) 2005 C M Western; see commandline.pas for license}
interface

uses
  {$IFDEF MSWINDOWS} Windows, Messages, {$ENDIF} ChildForm, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, NGrid, Mixture, ExtCtrls, StdCtrls, ComCtrls,
  Split, Menus, Buttons, GridEx, MNode;

type

  { TConstantsForm }

  TConstantsForm = class(TChildForm)
    Panel: TPanel;
    ParGrid: TNumberGrid;
    SelectorComboBox: TComboBox;  
    OptGrid: TStringGridEx;
    TreeView: TTreeView;
    SplitL: TSplit;
    SplitR: TSplit;
    TreePopupMenu: TPopupMenu;
    RenameItem: TMenuItem;
    FixAllButton: TSpeedButton;
    ConvertUnitsButton: TSpeedButton;
    CopyItem: TMenuItem;
    DeleteItem: TMenuItem;
    PasteItem: TMenuItem;
    StatusBar: TStatusBar;
    UnitsLabel: TLabel;
    ValuePanel: TPanel;
    CommentPanel: TPanel;
    Label1: TLabel;
    CommentEdit: TEdit;
    MoveUpItem: TMenuItem;
    MoveDownItem: TMenuItem;
    CopyWithLinkedItemsItem: TMenuItem;
    SelectPanel: TPanel;
    AddNewItem: TMenuItem;
    ConvertItem: TMenuItem;
    ParPopupMenu: TPopupMenu;
    CopyParItem: TMenuItem;
    PasteParItem: TMenuItem;
    EditParItem: TMenuItem;
    CutParItem: TMenuItem;
    ClearParItem: TMenuItem;
    procedure ClearParItemClick(Sender: TObject);
    procedure ParGridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: string);
    procedure ParGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: string);
    procedure ParPopupMenuPopup(Sender: TObject);
    procedure EditParItemClick(Sender: TObject);
    procedure PasteParItemClick(Sender: TObject);
    procedure CutParItemClick(Sender: TObject);
    procedure CopyParItemClick(Sender: TObject);
    procedure ConvertItemClick(Sender: TObject);
    procedure AddNewItemClick(Sender: TObject);
    procedure OptGridDblClick(Sender: TObject);
    procedure OptGridMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OptGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ParGridExit(Sender: TObject);
    procedure ParGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure ParGridChangeCellQuery(Sender: TObject; Col, Row: Integer;
      var CanChange: Boolean);
    procedure ParGridDblClick(Sender: TObject);
    procedure ParGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ParGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ParGridChanged(Sender: TObject; Col, Row: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure TreeViewEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure RenameItemClick(Sender: TObject);
    procedure OptGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure FixAllButtonClick(Sender: TObject);
    procedure ConvertUnitsButtonClick(Sender: TObject);
    procedure OptGridGetEditStyle(Sender: TObject; ACol, ARow: Integer;
      var Style: TEditStyle);
    procedure OptGridGetPickListItems(ACol, ARow: Integer;
      Items: TStrings);
    procedure CopyItemClick(Sender: TObject);
    procedure TreePopupMenuPopup(Sender: TObject);
    procedure PasteItemClick(Sender: TObject);
    procedure DeleteItemClick(Sender: TObject);
    procedure TreeViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDeactivate(Sender: TObject);
    procedure CommentEditChange(Sender: TObject);
    procedure MoveUpItemClick(Sender: TObject);
    procedure MoveDownItemClick(Sender: TObject);
    procedure CopyWithLinkedItemsItemClick(Sender: TObject);
  private
    LastCell: TPoint;
    LastError: string;
    LastRow: Integer; { of error }
    {$IFDEF LCL_}
    TurnOnEditing: Boolean;
    procedure TreeViewSelectionChanged(Sender: TObject);
    {$ENDIF}
    {$IFDEF VCL_}
    procedure WMHelp(var Message: TWMHelp); message WM_HELP;
    {$ENDIF}
  protected
    procedure MNodeChange(Sender: TMnode; Change: TMNodeChange; Index: Integer); override;
    procedure ParameterChanged(MNode: TMNode; Index: Integer); override;
    procedure SettingChanged(MNode: TMNode; Index: Integer); override;
    procedure PropNameChanged(MNode: TMNode; Index: Integer); override;
    function StuffObject(const Name1, Name2: string; MNode: TMNode; var ParentNode: TTreeNode): Integer; override;
    procedure CheckForNameChange;
    procedure UpdateActions; override;
  public
    function BaseNodeClass: TClass; override;
    procedure ShowItem(MNode: TMNode); override;
    procedure StuffSelector(MNode: TMNode); override;
    function DefaultCaption: string; virtual;
    procedure UpdateAlwaysVisible; virtual;
    function PasteItemsIntoTree: Boolean;
  end;

var
  ConstantsForm: TConstantsForm;

implementation

uses {$IFDEF LCL_} LResources, LCLType, AlignHelp, {$ENDIF}
     WCompat, MNodeClip, Overlay, ClipBrd, Main, RenForm, Units, WhatsThis, PropHelp;

{$IFNDEF FPC}
{$R *.dfm}
{$ENDIF}

{ TConstantsForm }

procedure TConstantsForm.StuffSelector(MNode: TMNode);
begin
  OptGrid.EditorMode := False;
  ParGrid.EditorMode := False;
  StatusBar.Panels[StatusBar.Panels.Count-1].Text := '';
  try
    inherited;
  except
    on E: Exception do
      StatusBar.Panels[StatusBar.Panels.Count-1].Text := E.Message;
  end;
  if Assigned(MNode) and (csDestroying in MNode.ComponentState) then
    MNode := nil;
  BeginUpdate;
  SelectorComboBox.Clear;
  SelectorComboBox.OnChange := {$IFDEF FPC}@{$ENDIF}ComboBoxChange;
  TreeView.Items.Clear;
  Stuff(MNode, '', nil);
  if SelectorComboBox.Items.Count > 0 then
    SelectorComboBox.ItemIndex := 0;
  EndUpdate(False);
  ComboBoxChange(SelectorComboBox);
  if Assigned(CurrentMNode) then begin
    TreeView.Items.GetFirstNode.Expand(True);
    TreeView.Items.GetFirstNode.Selected := True;
    Caption := CurrentMNode.Name + ' - ' + DefaultCaption;
  end else
    Caption := DefaultCaption;
  UpdateAlwaysVisible;
end;

procedure TConstantsForm.ParameterChanged(MNode: TMNode; Index: Integer);
begin
  ParGrid.Lbl[Index] := MNode.ParameterNames[Index];
  ParGrid[Index,1] := MNode.Parameters[Index];
  ParGrid.Valid[Index,2] := MNode.Floating[Index];
  if MNode.Increment[Index] = 0 then
    ParGrid.Valid[Index,3] := False
  else
    ParGrid[Index,3] := MNode.Increment[Index]
end;

procedure TConstantsForm.SettingChanged(MNode: TMNode; Index: Integer);
begin
  if OptGrid.EditorMode then Exit;
  OptGrid.Cells[0,Index-1] := MNode.SettingNames[Index];
  OptGrid.Cells[1,Index-1] := MNode.SettingToStr(Index);
  CheckForNameChange;
end;

procedure TConstantsForm.ShowItem(MNode: TMNode);
var
  i: Integer;
  procedure EmptyOptGrid;
  begin
    with OptGrid do begin
      FixedRows := 0;
      RowCount := 1;
      Cells[0,0] := '';
      Cells[1,0] := '';
    end;
  end;
  procedure EmptyParGrid;
  begin
    with ParGrid do begin
      FixedRows := 0;
      RowCount := 1;
      Lbl[0] := ' ';
      Valid[0,1] := False;
      Valid[0,2] := False;
      Valid[0,3] := False;
    end;
  end;
begin
  OptGrid.EditorMode := False;
  ParGrid.EditorMode := False;
  if Assigned(CurrentMNode) and (LastError <> '') then begin
    MessageDlg(LastError, mtError, [mbOK], 0);
    LastError := '';
    ShowItem(CurrentMNode);
    OptGrid.Row := LastRow;
    Exit;
  end;
  LastError := '';
  CurrentMNode := nil; { Lockout change notifications }
  if MNode = nil then begin
    EmptyParGrid;
    with ParGrid do begin
      FixedRows := 0;
      RowCount := 1;
    end;
    EmptyOptGrid;
    {$IFDEF LCL_}
    TreeView.Selected := nil;
    {$ELSE}
    TreeView.Select([]);
    {$ENDIF}
    CommentEdit.Text := '';
  end else begin
    {$IFDEF LCL_}
    TreeView.Selected := MNode.TreeNode;
    {$ELSE}
    TreeView.Select(MNode.TreeNode);
    {$ENDIF}
    { Order is inmportant here }
    if MNode.nParameters > 0 then begin
      ParGrid.RowCount := MNode.nParameters+1;
      ParGrid.FixedRows := 1;
    end else
     EmptyParGrid;
    for i := 1 to MNode.nParameters do
      ParameterChanged(MNode, i);
    if MNode.nSettings < 1 then
      EmptyOptGrid
    else begin
      OptGrid.RowCount := MNode.nSettings;
      for i := 1 to MNode.nSettings do
        SettingChanged(MNode, i);
      OptGrid.FixedRows := 0;
    end;
    SelectorComboBox.ItemIndex := MNode.ItemIndex;
    CurrentMNode := MNode;
    ParGrid.AutoAdjustColumn(0);
    ParGrid.AutoAdjustColumn(2);
    ParGrid.AutoAdjustColumn(3);
    {$IFDEF LCL_}
    OptGrid.AutoAdjustColumns;
    OptGrid.ColWidths[1] := OptGrid.ColWidths[1] + 20;
    {$ENDIF}
    CommentEdit.Text := CurrentMNode.Comment;
  end;
  UpdateAlwaysVisible;
end;

procedure TConstantsForm.ParGridChangeCellQuery(Sender: TObject; Col,
  Row: Integer; var CanChange: Boolean);
begin
  // CanChange := CanChange and ( (Col = 1) or (Col = 3) );
end;

procedure TConstantsForm.ParGridDblClick(Sender: TObject);
begin
  if (LastCell.Y > 0) and (LastCell.Y < ParGrid.RowCount) then
    if LastCell.X = 2 then
      ParGrid.Valid[LastCell.Y, 2] := not ParGrid.Valid[LastCell.Y, 2]
    {$IFDEF LCL}
    else if LastCell.X > 0 then
      TurnOnEditing := True; { Can't turn on EditorMode here, as it gets turned off again by pending messages }
    {$ENDIF}
end;

procedure TConstantsForm.ParGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  buffer: string;
begin
  if (ACol = 2) and (ARow > 0) then begin
    if ParGrid.Valid[ARow, ACol] then
      buffer := 'yes'
    else
      buffer := 'no';
    TextInGrid(ParGrid.Canvas, Rect, buffer);
  end;
end;

procedure TConstantsForm.ParGridMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ParGrid.MouseToCell(X, Y, LastCell.X, LastCell.Y);
end;

procedure TConstantsForm.ParGridChanged(Sender: TObject; Col,
  Row: Integer);
begin
  if Assigned(CurrentMNode) then
    case Col of
      1: CurrentMNode.SetParameter(Row, ParGrid[Row, Col]);
      2: CurrentMNode.Floating[Row] := ParGrid.Valid[Row, Col];
      3: if ParGrid.Valid[Row, Col] and (ParGrid[Row, Col] > 0) then
           CurrentMNode.Increment[Row] := ParGrid[Row, Col]
         else begin
           CurrentMNode.Increment[Row] := 0;
           ParGrid.Valid[Row,Col] := False;
         end;
    end;
end;

procedure TConstantsForm.FormCreate(Sender: TObject);
begin
  {$IFDEF LCL_}
  ParGrid.Options := ParGrid.Options + [goDblClickAutoSize];
  OptGrid.Options := ParGrid.Options + [goDblClickAutoSize];
  TreeView.OnSelectionChanged := @TreeViewSelectionChanged;
  StatusBar.SimplePanel := False;
  FixAllButton.Width := FixAllButton.Width + 4;
  ConvertUnitsButton.Width := ConvertUnitsButton.Width + 4;
  FixAllButton.Flat := False;
  ConvertUnitsButton.Flat := False;
  {$ENDIF}
end;

procedure TConstantsForm.FormDestroy(Sender: TObject);
begin
  if ConstantsForm = Self then
    ConstantsForm := nil;
end;

procedure TConstantsForm.FormResize(Sender: TObject);
begin
  SplitL.ParentResized;
  SplitR.ParentResized;
  {$IFDEF LCL_}
  AlControl(nil);
  AlControl(Label1);
  AlControl(CommentEdit);
  AlControl(nil);
  AlControl(UnitsLabel);
  AlControl(ConvertUnitsButton,4,akRight);
  AlControl(FixAllButton,0,akRight);
  AlControl(SelectorComboBox,4,akRight);
  {$ENDIF}
end;

procedure TConstantsForm.TreeViewChange(Sender: TObject; Node: TTreeNode);
var
  MNode: TMNode;
begin
  if Assigned(Node) then
    MNode := TMNode(Node.Data)
  else
    MNode := nil;
  CheckForNameChange;
  ShowItem(MNode);
end;

{$IFDEF LCL_}
procedure TConstantsForm.TreeViewSelectionChanged(Sender: TObject);
begin
  TreeViewChange(Sender, TreeView.Selected);
end;
{$ENDIF}

procedure TConstantsForm.TreeViewEdited(Sender: TObject; Node: TTreeNode; var S: String);
begin
  CurrentMNode := TMNode(Node.Data);
  BeginUpdate;
  try
    CurrentMNode.Name := S;
    RenameForm.RenameMNodePairsAsRequired(CurrentMNode.RootNode);
  finally
    EndUpdate(False, True);
  end;
end;

procedure TConstantsForm.RenameItemClick(Sender: TObject);
{$IFDEF LCL_}
var
  s: string;
{$ENDIF}
begin
  if Assigned(CurrentMNode) then
    if CurrentMNode is TMNodePair then
      RenameForm.Rename(CurrentMNode as TMNodePair)
    else begin
      {$IFDEF LCL_}
      { TODO: Remove when LCL implements inplace rename }
      s := CurrentMNode.Name;
      if InputQuery('Rename Item', 'New Name:', s) then
        TreeViewEdited(nil, CurrentMNode.TreeNode, s);
      {$ELSE}
      TreeView.Selected.EditText;
      {$ENDIF}
    end;
end;

procedure TConstantsForm.OptGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  if Assigned(CurrentMNode) and (ACol = 1) and (Trim(OptGrid.Cells[ACol, ARow]) <> '') then
    try
      LastError := '';
      try
        BeginUpdate;
        CurrentMNode.SetSettingFromStr(ARow+1, OptGrid.Cells[ACol, ARow]);
        if Pos('...', Value) > 0 then
          OptGrid.Cells[ACol, ARow] := CurrentMNode.SettingToStr(ARow+1);
      finally
        EndUpdate(False);
      end;
    except
      on E: Exception do begin
        LastRow := ARow;
        LastError := E.Message;
        StatusBar.Panels[StatusBar.Panels.Count-1].Text := E.Message;
      end;
    end;
end;

procedure TConstantsForm.FixAllButtonClick(Sender: TObject);
begin
  if Assigned(BaseNode) then
    BaseNode.FixAll(True);
end;

function TConstantsForm.DefaultCaption: string;
begin
  Result := 'Constants';
end;

procedure TConstantsForm.ConvertUnitsButtonClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.CycleUnits;
end;

procedure TConstantsForm.OptGridGetEditStyle(Sender: TObject; ACol, ARow: Integer; var Style: TEditStyle);
begin
  if Assigned(CurrentMNode) and CurrentMNode.IsSettingEnum(ARow+1) then
    Style := esPickList;
end;

procedure TConstantsForm.OptGridGetPickListItems(ACol, ARow: Integer; Items: TStrings);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.GetEnumNames(ARow+1, Items);
end;

procedure TConstantsForm.CopyItemClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.CopyToClipboard;
end;

procedure TConstantsForm.TreePopupMenuPopup(Sender: TObject);
var
  i: Integer;
  MenuItem: TMenuItem;
begin
  if Assigned(TreeView.Selected) then
    TreeView.Selected.Selected := True;
  CopyWithLinkedItemsItem.Visible := Assigned(CurrentMNode) and (CurrentMNode.LinkedNodes > 0);
  PasteItem.Enabled := Clipboard.HasFormat(MNodeClipboardFormat);
  MoveUpItem.Enabled := Assigned(CurrentMNode) and Assigned(CurrentMNode.Owner)
                        and (CurrentMNode.ComponentIndex > 0);
  MoveDownItem.Enabled := Assigned(CurrentMNode) and Assigned(CurrentMNode.Owner)
                          and (CurrentMNode.ComponentIndex < CurrentMNode.Owner.ComponentCount-1);
  ConvertItem.Visible := CurrentMNode is TState;
  if Assigned(CurrentMNode)
     and (CurrentMNode.nChildTypes > 0) and Assigned(CurrentMNode.ChildTypes[0])
     and not (CurrentMNode is TOverlays) then begin
    AddNewItem.Enabled := True;
    AddNewItem.Clear;
    if CurrentMNode.nChildTypes > 1 then begin
      AddNewItem.Caption := '&Add new ...';
      AddNewItem.Tag := -1;
      for i := 0 to CurrentMNode.nChildTypes-1 do
        if Assigned(CurrentMNode.ChildTypes[i]) then begin
          MenuItem := TMenuItem.Create(AddNewItem);
          MenuItem.Caption := CurrentMNode.ChildTypes[i].DisplayClassName;
          MenuItem.Hint := 'Add new object'; { TODO: Make F1 work }
          MenuItem.Tag := i;
          MenuItem.OnClick := {$IFDEF FPC}@{$ENDIF}AddNewItemClick;
          AddNewItem.Add(MenuItem);
        end;
    end else begin
      AddNewItem.Tag := 0;
      AddNewItem.Caption := '&Add new ' + CurrentMNode.ChildTypes[0].DisplayClassName;
    end;
  end else begin
    AddNewItem.Caption := '&Add new ...';
    AddNewItem.Enabled := False;
  end;
end;

procedure TConstantsForm.PasteItemClick(Sender: TObject);
begin
  PasteItemsIntoTree;
end;

procedure TConstantsForm.DeleteItemClick(Sender: TObject);
var
  R: Integer;
begin
  BeginUpdate;
  try
    if Assigned(CurrentMNode) then begin
      if CurrentMNode.LinkedNodes > 0 then begin
         R := Application.MessageBox(PChar(CurrentMNode.UniqueName + ' has linked nodes. Delete these also?'),
                                'Question', MB_YESNOCANCEL or MB_ICONQUESTION);
         if R = IDYES then
           CurrentMNode.LinkedNodes(True)
         else if R = IDCANCEL then
           Exit;
      end else
       if Application.MessageBox(PChar('Are you sure you want to delete ' + CurrentMNode.UniqueName + '?'),
                                 'Warning', MB_YESNO or MB_ICONQUESTION) = IDNO then
         Exit;
      CurrentMNode.Free;
    end;
  finally
    EndUpdate;
  end;
end;

procedure TConstantsForm.TreeViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) and Assigned(TreeView.Selected) then
    TreeView.Selected.Selected := True;
end;

function TConstantsForm.BaseNodeClass: TClass;
begin
  Result := TMixture;
end;

function TConstantsForm.StuffObject(const Name1, Name2: string; MNode: TMNode; var ParentNode: TTreeNode): Integer;
begin
  SelectorComboBox.AddItem(Name1 + Name2, MNode);
  Result := SelectorComboBox.Items.Count-1;
  {$IFDEF LCL_}
  ParentNode := TreeView.Items.AddChildObject(ParentNode, Name2, MNode);
  {$ELSE}
  ParentNode := TreeView.Items.AddNode(nil, ParentNode, Name2, MNode, naAddChild);
  {$ENDIF}
  MNode.TreeNode := ParentNode;
  MNode.ItemIndex := Result;
end;

procedure TConstantsForm.CheckForNameChange;
begin
  if Assigned(CurrentMNode) and  (CurrentMNode.UniqueName <> CurrentMNodeName) then
    ReStuff;
end;

{$IFDEF LCL_}
type
  TOpenCustomGrid = class(TCustomGrid)
  end;
{$ENDIF}
procedure TConstantsForm.UpdateActions;
begin
  inherited UpdateActions;
  if not (ParGrid.EditorMode or OptGrid.EditorMode) then begin
    CheckForNameChange;
    {$IFDEF LCL_}
    if TurnOnEditing and ((ActiveControl = ParGrid) or (ActiveControl = OptGrid)) then
      TOpenCustomGrid(ActiveControl).EditorMode := True;
    {$ENDIF}
  end;
  {$IFDEF LCL_}
  TurnOnEditing := False;
  {$ENDIF}
end;

procedure TConstantsForm.FormDeactivate(Sender: TObject);
begin
  ParGrid.EditorMode := False;
  OptGrid.EditorMode := False;
end;

procedure TConstantsForm.PropNameChanged(MNode: TMNode; Index: Integer);
var
  i: Integer;
begin
  for i := 1 to CurrentMNode.nSettings do
    if OptGrid.Cells[0,i-1] <> MNode.SettingNames[i] then
       OptGrid.Cells[0,i-1] := MNode.SettingNames[i];
  for i := 1 to MNode.nParameters do
    if ParGrid.Lbl[i] <> MNode.ParameterNames[i] then
      ParGrid.Lbl[i] := MNode.ParameterNames[i];
end;

procedure TConstantsForm.CommentEditChange(Sender: TObject);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.Comment := CommentEdit.Text;
end;

procedure TConstantsForm.MNodeChange(Sender: TMnode; Change: TMNodeChange;
  Index: Integer);
begin
  inherited;
  UpdateAlwaysVisible;
end;

procedure TConstantsForm.UpdateAlwaysVisible;
begin
  { Special call for variable that is always visible }
  if Visible and Assigned(BaseNode) then
    UnitsLabel.Caption := (BaseNode as TStreamableMNode).UnitsName;
end;

procedure TConstantsForm.MoveUpItemClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) and Assigned(CurrentMNode.Owner) then
    CurrentMNode.ComponentIndex := CurrentMNode.ComponentIndex-1;
  ReStuff;
end;

procedure TConstantsForm.MoveDownItemClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) and Assigned(CurrentMNode.Owner) then
    CurrentMNode.ComponentIndex := CurrentMNode.ComponentIndex+1;
  ReStuff;
end;

procedure TConstantsForm.CopyWithLinkedItemsItemClick(Sender: TObject);
begin
  if Assigned(CurrentMNode) then
    CurrentMNode.CopyToClipboard(True);
end;

{$IFDEF VCL_}
type
  TOpenCustomGrid = class(TCustomGrid)
  end;

procedure TConstantsForm.WMHelp(var Message: TWMHelp);
var
  InPlaceEditor: Boolean;
  function Involves(Control: TWinControl):Boolean;
  begin
    Result := True;
    InPlaceEditor := False;
    if Control.Handle <> Message.HelpInfo.hItemHandle then
      if Control.Handle <>  GetParent(Message.HelpInfo.hItemHandle) then
        Result := False { Inplace editor }
      else
        InPlaceEditor := True;
  end;
  function TryGrid(Grid: TCustomGrid):Boolean;
  var
    Point: TPoint;
    Coord: TGridCoord;
    BookMark: string;
  begin
    Result := Involves(Grid);
    if not Result then Exit;
    if InContextHelp and not InPlaceEditor then begin
      Point := Grid.ScreenToClient(Message.HelpInfo.MousePos);
      Coord := Grid.MouseCoord(Point.X, Point.Y);
    end;
    if not InContextHelp or InPlaceEditor or (Coord.Y < TOpenCustomGrid(Grid).FixedRows) or (Coord.Y > TOpenCustomGrid(Grid).RowCount) then
      Coord.Y := TOpenCustomGrid(Grid).Row;
    if Grid = ParGrid then
      BookMark := CurrentMnode.ParameterNames[Coord.Y]
    else
      BookMark := CurrentMNode.SettingNames[Coord.Y+1];
    Application.HelpSystem.ShowTopicHelp(Copy(CurrentMnode.ClassType.ClassName,2,255)+'.htm#'
                                         +BookMark, Application.CurrentHelpFile);
  end;
  function TryTreeView(TreeView: TTreeView):Boolean;
  var
    TreeNode: TTreeNode;
    MNode: TMnode;
    Point: TPoint;
  begin
    Result := Involves(TreeView);
    MNode := nil;
    if InContextHelp then begin
      Point := TreeView.ScreenToClient(Message.HelpInfo.MousePos);
      TreeNode := TreeView.GetNodeAt(Point.X, Point.Y);
      if Assigned(TreeNode) then
        MNode := TMNode(TreeNode.Data);
    end;
    if not Assigned(MNode) then
      MNode := CurrentMNode;
    Application.HelpSystem.ShowTopicHelp(Copy(MNode.ClassType.ClassName,2,255)+'.htm',
                                         Application.CurrentHelpFile);
  end;
begin
  if InHelp then Exit;
  if not (csDesigning in ComponentState)
     and (Message.HelpInfo.iContextType = HELPINFO_WINDOW)
     and Assigned(CurrentMNode) then begin
    if TryGrid(ParGrid) or TryGrid(OptGrid) then
      Exit;
    if TryTreeView(TreeView) then
      Exit;
  end;
  inherited;
end;
{$ENDIF}

procedure TConstantsForm.ParGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  if Assigned(CurrentMNode) then
    StatusBar.Panels[StatusBar.Panels.Count-1].Text := CurrentMNode.HelpOnParameter(ARow);
end;

procedure TConstantsForm.ParGridExit(Sender: TObject);
begin
  StatusBar.Panels[StatusBar.Panels.Count-1].Text := '';
  CheckForNameChange;
end;

procedure TConstantsForm.OptGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  if Assigned(CurrentMNode) then
    StatusBar.Panels[StatusBar.Panels.Count-1].Text := CurrentMNode.HelpOnSetting(ARow+1);
  CheckForNameChange;
end;

procedure TConstantsForm.AddNewItemClick(Sender: TObject);
var
  MNode: TMNode;
  {$IFDEF LCL}
  s: string;
  i: Integer;
  {$ENDIF}
begin
  if Assigned(CurrentMNode) then
    with Sender as TMenuItem do
      if Tag >= 0 then begin
        BeginUpdate;
        MNode := CurrentMNode.ChildTypes[Tag].Create(CurrentMNode);
        if not (MNode is TMNodePair) then
          MNode.Name := 'New ' + MNode.DisplayClassName;
        try
          RenameForm.RenameMNodePairsAsRequired(MNode);
        except
          MNode.Free;
          raise;
        end;
        {$IFDEF LCL}
        if MNode is TMNodePair then begin
          { LCL has problems with treeview items with identical names, so shift new node to
            top if necessary }
          s := MNode.UniqueName;
          for i := 0 to CurrentMNode.Count-1 do
            if (CurrentMNode.Items[i] <> MNode) and (CurrentMNode.Items[i].UniqueName = s) then begin
              MNode.ComponentIndex := 0;
              ReStuff;
              Break;
            end;
        end;
        {$ENDIF}
        CurrentMNode := MNode;
        EndUpdate;
      end;
end;

procedure TConstantsForm.OptGridDblClick(Sender: TObject);
begin
  {$IFDEF LCL}
  if LastCell.X = 1 then
    TurnOnEditing := True; { Can't turn on EditorMode here, as it gets turned off again by pending messages }
  {$ENDIF}
end;

procedure TConstantsForm.OptGridMouseDown(Sender: TOBject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  OptGrid.MouseToCell(X, Y, LastCell.X, LastCell.Y);
end;

procedure TConstantsForm.ConvertItemClick(Sender: TObject);
begin
  if MessageDlg('Are you sure you want to convert the parameters?', mtConfirmation, mbYesNo, 0) <> mrYes then
    Exit;
  BeginUpdate;
  if CurrentMNode is TState then
    TState(CurrentMNode).ConvertToPerturbations;
  EndUpdate;
end;

function TConstantsForm.PasteItemsIntoTree: Boolean;
var
  MNode: TMNode;
begin
  BeginUpdate;
  MNode := PasteXMLNodeOnto(CurrentMNode);
  Result := Assigned(MNode);
  if Result then
    CurrentMNode := Mnode;
  EndUpdate;
end;

procedure TConstantsForm.CopyParItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard;
end;

procedure TConstantsForm.CutParItemClick(Sender: TObject);
begin
  ParGrid.CopyToClipboard;
  ParGrid.ClearSelection;
end;

procedure TConstantsForm.PasteParItemClick(Sender: TObject);
begin
  ParGrid.PasteFromClipboard;
end;

procedure TConstantsForm.EditParItemClick(Sender: TObject);
begin
  ParGrid.EditorMode := True;
end;

procedure TConstantsForm.ParPopupMenuPopup(Sender: TObject);
begin
  PasteParItem.Enabled := ClipboardHasText;
end;

procedure TConstantsForm.ParGridGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: string);
begin
  if ACol = 2 then
    if ParGrid.Valid[ARow,ACol] then
      Value := 'yes'
    else
      Value := 'no';
end;

procedure TConstantsForm.ParGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: string);
begin
  if ACol = 2 then
    ParGrid.Valid[ARow,ACol] := StrToBoolean(Value);
end;

procedure TConstantsForm.ClearParItemClick(Sender: TObject);
begin
  ParGrid.ClearSelection;
end;

initialization
{$IFDEF LCL_}
  {$I constfrm.lrs}
{$ENDIF}

end.
