unit AirVac;
{$I DFS.inc}{ Copyright (C) 2005 C M Western; see UCompat.pas for license}

interface

function Refrac(s:Double):Double; { Refractive index of air at s (in cm-1) }
function Air(a:Double):Double; { Return air wavelength/nm given vacuum wavenumber/cm-1 }
function Vac(a:Double):Double; { Return vacuum wavenumber/cm-1 given air wavelength/nm }

implementation

function Refrac(s:Double):Double; { Refractive index of air at s (in cm-1) }
var
  n: Double;
begin
  n := 1e-8*s*s;
  n := 8342.13 + 2406030./(130-n) + 15997/(38.9-n);
  Result := 1 + 1e-8*n;
end;

function Air(a:Double):Double;
begin
  Result := 1e7/a/Refrac(a);
end;

function Vac(a:Double):Double;
begin
  Result := refrac(1e7/a);
  Result := refrac(1e7/a/Result);
  Result := refrac(1e7/a/Result);
  Result := refrac(1e7/a/Result);
  Result := 1e7/a/Result;
end;


end.
